Inhalte

# Anweisung GoSub…Return

Ruft eine Subroutine auf, die durch "label" innerhalb einer Sub oder einer Function angezeigt wird. Die auf "label" folgenden Anweisungen werden bis zur nächsten Anweisung Return ausgeführt. Danach fährt das Programm mit der Anweisung fort, die der Anweisung GoSub folgt.

### Syntax:

    GoSub label[:]

### Parameter:

label: Eine Zeilenkennung, die angibt, wo die Ausführung fortgesetzt werden soll. Der Geltungsbereich von "label" in der Routine, zu der es gehört.

Die Anweisung GoSub ruft eine lokale Subroutine, die durch "label" gekennzeichnet ist, innerhalb einer Subroutine oder Funktion auf. Der Name von "label" muss mit einem Doppelpunkt (":") enden.

      Sub/Function foo
          ' Anweisungen
          GoSub label
          ' Anweisungen
          Exit Sub/Function
      label:
          ' Anweisungen
          Return
      End Sub/Function

Trifft das Programm auf eine Return-Anweisung, ohne dass zuvor ein GoSub erfolgte, meldet LibreOffice Basic eine Fehlermeldung. Sie müssen selber dafür Sorge tragen, dass Ihr Programm ein Unterprogramm oder eine Funktion mit der Anweisung Exit Sub beziehungsweise der Anweisung Exit Function (siehe dort) verlässt, bevor es auf einen Programmteil stößt, der mit Return abgeschlossen ist.

Das folgende Beispiel demonstriert die Verwendung von GoSub und Return. Das Programm berechnet die Quadratwurzeln zweier vom Benutzer eingegebener Zahlen, indem es einen bestimmten Programmabschnitt zweimal ausführt.

### Beispiel:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox("Bitte geben Sie die erste Zahl ein: ","Zahleingabe"))
        iInputb = Int(InputBox("Bitte geben Sie die zweite Zahl ein: ","Zahleingabe"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "Die Quadratwurzel aus";iInputa;" ist";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "Die Quadratwurzel aus";iInputb;" ist";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub

Verwandte Themen

Anweisung GoTo

Anweisung On … GoSub; Anweisung On … GoTo

Bitte unterstützen Sie uns!